unit Main;

interface

uses
  Windows, Classes, Controls, Graphics, Forms, ComCtrls, StdCtrls, ShDocVW,
  acClasses, acFormPlacementSaver, acCaptionButton, acFormTopmost,
  acAwayTimer, acIESniffer;

type
  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    GroupBox1: TGroupBox;
    ListView1: TListView;
    acIESniffer1: TacIESniffer;
    GroupBox2: TGroupBox;
    ListBox1: TListBox;
    acFormTopmost1: TacFormTopmost;
    acFormPlacementSaver1: TacFormPlacementSaver;
    GroupBox3: TGroupBox;
    KeywordsEdit: TEdit;
    MarkBtn: TButton;
    ClearBtn: TButton;
    procedure acIESniffer1WindowLoad(Sender: TObject; const URL: String;
      const Browser: IWebBrowser2; State: TacWindowLoadState);
    procedure acIESniffer1WindowUnload(Sender: TObject; const URL: String);
    procedure acIESniffer1WBBeforeNavigate2(Sender: TObject;
      const URL: String; const Browser: IWebBrowser2;
      const pDisp: IDispatch; var NewURL, Flags, TargetFrameName, PostData,
      Headers: OleVariant; var Cancel: WordBool);
    procedure acIESniffer1WBCommandStateChange(Sender: TObject;
      const URL: String; const Browser: IWebBrowser2; Command: Integer;
      Enable: WordBool);
    procedure acIESniffer1WBDocumentComplete(Sender: TObject;
      const URL: String; const Browser: IWebBrowser2;
      const pDisp: IDispatch; var NewURL: OleVariant);
    procedure acIESniffer1WBDownloadBegin(Sender: TObject;
      const URL: String; const Browser: IWebBrowser2);
    procedure acIESniffer1WBDownloadComplete(Sender: TObject;
      const URL: String; const Browser: IWebBrowser2);
    procedure acIESniffer1WBFullScreen(Sender: TObject; const URL: String;
      const Browser: IWebBrowser2; FullScreen: WordBool);
    procedure acIESniffer1WBMenuBar(Sender: TObject; const URL: String;
      const Browser: IWebBrowser2; MenuBar: WordBool);
    procedure acIESniffer1WBNavigateComplete2(Sender: TObject;
      const URL: String; const Browser: IWebBrowser2;
      const pDisp: IDispatch; var NewURL: OleVariant);
    procedure acIESniffer1WBNewWindow2(Sender: TObject; const URL: String;
      const Browser: IWebBrowser2; var ppDisp: IDispatch;
      var Cancel: WordBool);
    procedure acIESniffer1WBProgressChange(Sender: TObject;
      const URL: String; const Browser: IWebBrowser2; Progress,
      ProgressMax: Integer);
    procedure acIESniffer1WBPropertyChange(Sender: TObject;
      const URL: String; const Browser: IWebBrowser2;
      const szProperty: WideString);
    procedure acIESniffer1WBQuit(Sender: TObject; const URL: String;
      const Browser: IWebBrowser2);
    procedure acIESniffer1WBStatusBar(Sender: TObject; const URL: String;
      const Browser: IWebBrowser2; StatusBar: WordBool);
    procedure acIESniffer1WBStatusTextChange(Sender: TObject;
      const URL: String; const Browser: IWebBrowser2;
      var Text: WideString);
    procedure acIESniffer1WBTheaterMode(Sender: TObject; const URL: String;
      const Browser: IWebBrowser2; TheaterMode: WordBool);
    procedure acIESniffer1WBTitleChange(Sender: TObject; const URL: String;
      const Browser: IWebBrowser2; const Text: WideString);
    procedure acIESniffer1WBToolBar(Sender: TObject; const URL: String;
      const Browser: IWebBrowser2; ToolBar: WordBool);
    procedure acIESniffer1WBVisible(Sender: TObject; const URL: String;
      const Browser: IWebBrowser2; Visible: WordBool);
    procedure acIESniffer1URLChange(Sender: TObject; const URL: String;
      const Browser: IWebBrowser2);
    procedure MarkBtnClick(Sender: TObject);
    procedure ClearBtnClick(Sender: TObject);
  private
  public
    procedure Log(const St, URL: String);
    procedure RefreshActiveInstancesView;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Log(const St, URL: String);
begin
  ListBox1.Items.Add(St + ': ' + URL);
  ListBox1.ItemIndex := ListBox1.Items.Count - 1;
end;

procedure TForm1.RefreshActiveInstancesView;
var
  I: Integer;
  ListItem: TListItem;
begin
  with ListView1, Items do
   try
     BeginUpdate;
     Clear;

     I := acIESniffer1.IEList.Count;
     if I <> 0 then
      for I := 0 to I - 1 do
       with acIESniffer1.IEList[I] do
        try
         ListItem := Items.Add;
         ListItem.Caption := URL;
         ListItem.SubItems.Add(Browser.LocationName);
        except
        end;
   finally
     EndUpdate;
   end;
end;

procedure TForm1.acIESniffer1WindowLoad(Sender: TObject; const URL: String;
  const Browser: IWebBrowser2; State: TacWindowLoadState);
const
  StateStr: Array[TacWindowLoadState] of String = ('Exists Loading', 'Exists Completed', 'New Loading', 'New Completed');
begin
  Log(StateStr[State], URL);
  RefreshActiveInstancesView;
end;

procedure TForm1.acIESniffer1WindowUnload(Sender: TObject;
  const URL: String);
begin
  Log('Unload', URL);
end;

procedure TForm1.acIESniffer1WBBeforeNavigate2(Sender: TObject;
  const URL: String; const Browser: IWebBrowser2; const pDisp: IDispatch;
  var NewURL, Flags, TargetFrameName, PostData, Headers: OleVariant;
  var Cancel: WordBool);
begin
  Log('BeforeNavigate2 to', NewURL);
end;

procedure TForm1.acIESniffer1WBCommandStateChange(Sender: TObject;
  const URL: String; const Browser: IWebBrowser2; Command: Integer;
  Enable: WordBool);
begin
  Log('CommandStateChange', URL);
end;

procedure TForm1.acIESniffer1WBDocumentComplete(Sender: TObject;
  const URL: String; const Browser: IWebBrowser2; const pDisp: IDispatch;
  var NewURL: OleVariant);
begin
  Log('DocumentComplete', NewURL);
end;

procedure TForm1.acIESniffer1WBDownloadBegin(Sender: TObject;
  const URL: String; const Browser: IWebBrowser2);
begin
  Log('DownloadBegin', URL);
end;

procedure TForm1.acIESniffer1WBDownloadComplete(Sender: TObject;
  const URL: String; const Browser: IWebBrowser2);
begin
  Log('DownloadComplete', URL);
//  IEMarkText(Browser, 'Delphi', clBlack, clYellow);
end;

procedure TForm1.acIESniffer1WBFullScreen(Sender: TObject;
  const URL: String; const Browser: IWebBrowser2; FullScreen: WordBool);
begin
  Log('FullScreen', URL);
end;

procedure TForm1.acIESniffer1WBMenuBar(Sender: TObject; const URL: String;
  const Browser: IWebBrowser2; MenuBar: WordBool);
begin
  Log('MenuBar', URL);
end;

procedure TForm1.acIESniffer1WBNavigateComplete2(Sender: TObject;
  const URL: String; const Browser: IWebBrowser2; const pDisp: IDispatch;
  var NewURL: OleVariant);
begin
  Log('NavigateComplete', NewURL);
end;

procedure TForm1.acIESniffer1WBNewWindow2(Sender: TObject;
  const URL: String; const Browser: IWebBrowser2; var ppDisp: IDispatch;
  var Cancel: WordBool);
begin
  Log('NewWindow2', URL);
end;

procedure TForm1.acIESniffer1WBProgressChange(Sender: TObject;
  const URL: String; const Browser: IWebBrowser2; Progress,
  ProgressMax: Integer);
begin
  Log('ProgressChange', URL);
end;

procedure TForm1.acIESniffer1WBPropertyChange(Sender: TObject;
  const URL: String; const Browser: IWebBrowser2;
  const szProperty: WideString);
begin
  Log('PropertyChange', URL);
end;

procedure TForm1.acIESniffer1WBQuit(Sender: TObject; const URL: String;
  const Browser: IWebBrowser2);
begin
  Log('Quit', URL);
  RefreshActiveInstancesView;  
end;

procedure TForm1.acIESniffer1WBStatusBar(Sender: TObject;
  const URL: String; const Browser: IWebBrowser2; StatusBar: WordBool);
begin
  Log('StatusBar', URL);
end;

procedure TForm1.acIESniffer1WBStatusTextChange(Sender: TObject;
  const URL: String; const Browser: IWebBrowser2; var Text: WideString);
begin
  StatusBar1.SimpleText := Text;
end;

procedure TForm1.acIESniffer1WBTheaterMode(Sender: TObject;
  const URL: String; const Browser: IWebBrowser2; TheaterMode: WordBool);
begin
  Log('TheaterMode', URL);
end;

procedure TForm1.acIESniffer1WBTitleChange(Sender: TObject;
  const URL: String; const Browser: IWebBrowser2; const Text: WideString);
begin
  Log('TitleChange', URL);
  RefreshActiveInstancesView;  
end;

procedure TForm1.acIESniffer1WBToolBar(Sender: TObject; const URL: String;
  const Browser: IWebBrowser2; ToolBar: WordBool);
begin
  Log('ToolBar', URL);
end;

procedure TForm1.acIESniffer1WBVisible(Sender: TObject; const URL: String;
  const Browser: IWebBrowser2; Visible: WordBool);
begin
  Log('Visible', URL);
end;

procedure TForm1.acIESniffer1URLChange(Sender: TObject; const URL: String;
  const Browser: IWebBrowser2);
begin
  Log('URL Changed', URL);
  RefreshActiveInstancesView;  
end;

procedure TForm1.MarkBtnClick(Sender: TObject);
var
  I: Integer;
begin
  I := acIESniffer1.IEList.Count;
  if I <> 0 then
   for I := 0 to I - 1 do // enumerate Browser windows
    with acIESniffer1.IEList[I] do
     if IsReady then // if it ready to be modified
      IEMarkKeywords(Browser, KeywordsEdit.Text, ' ');
end;

procedure TForm1.ClearBtnClick(Sender: TObject);
var
  I: Integer;
begin
  I := acIESniffer1.IEList.Count;
  if I <> 0 then
   for I := 0 to I - 1 do // enumerate Browser windows
    with acIESniffer1.IEList[I] do
     if IsReady then // if it ready to be modified
      IEClearMarks(Browser);
end;

end.
